# This is a BitKeeper generated patch for the following project:
# Project Name: Linux kernel tree
# This patch format is intended for GNU patch command version 2.5 or higher.
# This patch includes the following deltas:
#	           ChangeSet	1.639   -> 1.640  
#	drivers/usb/input/Makefile	1.8     -> 1.9    
#	drivers/usb/input/Config.help	1.4     -> 1.5    
#	drivers/usb/input/Config.in	1.5     -> 1.6    
#	               (new)	        -> 1.1     Documentation/input/xpad.txt
#	               (new)	        -> 1.1     drivers/usb/input/xpad.c
#
# The following is the BitKeeper ChangeSet Log
# --------------------------------------------
# 02/07/12	vojtech@suse.cz	1.640
# [PATCH] New driver for the X-Box gamepads
# 
# Attached is a BK patch to add a new driver for X-Box gamepads. It's
# fairly simple, and I think it can be put into the 2.5 tree.
# --------------------------------------------
#
diff -Nru a/Documentation/input/xpad.txt b/Documentation/input/xpad.txt
--- /dev/null	Wed Dec 31 16:00:00 1969
+++ b/Documentation/input/xpad.txt	Fri Jul 12 11:44:59 2002
@@ -0,0 +1,84 @@
+usb-xpad - Linux USB driver for XBOX HID gamecontrollers
+
+This is the very first release of a driver for XBOX gamecontrollers.
+Basically, this was hacked away in just a few hours, so don't expect
+miracles.
+
+0. Status
+---------
+
+For now, this driver has only been tested on just one Linux-Box.
+This one is running a 2.4.18 kernel with usb-uhci on an amd athlon 600.
+
+The jstest-program from joystick-1.2.15 (jstest-version 2.1.0) reports
+8 axes and 10 buttons.
+
+Alls 8 axes work, though they all have the same range (-32768..32767)
+and the zero-setting is not correct for the triggers.
+9 of the 10 buttons work (my black button does not work, though I can
+see no reason for it not to), all of them are in digital mode, though
+(the six buttons on the right side are "analog" ones).
+
+
+1. USB adapter
+--------------
+
+Before you can actually use the driver, you need to get yourself an
+adapter cable to connect the XBOX-controller to your Linux-Box.
+
+Such a cable is pretty easy to build. The Controller itself is a USB device
+(a hub with three ports; two expansion slots and the controller device)
+with the only differnce in a nonstandard connector (5 pins vs. 4 on
+standard USB connector).
+
+You just need to solder an USB connector onto the cable and keep the
+yellow wire unconnected. The other pins have the same order on both
+connectors so there no magic to it. Detailed info on these matters can be found
+on the net.
+
+Thanks to the trip splitter found on the cable you don't even need to cut the
+original cable, you can buy an extension cable and cut that instead. That way,
+you can still use the controller with your XBOX, if you have one ;)
+
+
+2. driver installation
+----------------------
+
+Once you have the adapter cable and the controller is connected, you need
+to load your USB subsystem and should cat /proc/bus/usb/devices.
+There should be an entry like the one in InterAct_german.dump.
+
+Don't worry if the vendor and/or product ID don't match, those are easy to
+add to the driver. You could do it yourself, just add the appropriate line
+into the list after the line
+    '} xpad_device[] = {'
+, but before the line that says
+    '{ 0x0000, 0x0000, "unknown...." }'.
+
+In theory, the driver should work with other controllers than mine
+(InterAct PowerPad pro, bought in Germany) just fine, but see for yourself.
+
+If you compiled and installed the driver, test the functionality:
+> modprobe usb-xpad
+> modprobe joydev
+> jstest /dev/input/js0
+
+There should be a single line showing 18 inputs (8 axes, 10 buttons), and
+it's values should change if you move the sticks and push the buttons.
+
+It works? Voila, your done ;)
+
+
+3. Thanks
+---------
+
+I have to thank ITO Takayuki for the detailed info on his site
+ http://euc.jp/periphs/xbox-controller.ja.html.
+ 
+His useful info and both the usb-skeleton as well as the iforce input driver
+helped a lot in rapid prototyping the basic functionality.
+
+
+-- 
+Marko Friedemann <mfr@bmx-chemnitz.de>
+2002-07-02
diff -Nru a/drivers/usb/input/Config.help b/drivers/usb/input/Config.help
--- a/drivers/usb/input/Config.help	Fri Jul 12 11:44:59 2002
+++ b/drivers/usb/input/Config.help	Fri Jul 12 11:44:59 2002
@@ -114,3 +114,17 @@
   inserted in and removed from the running kernel whenever you want).
   The module will be called powermate.o. If you want to compile it as a
   module, say M here and read <file:Documentation/modules.txt>.
+
+CONFIG_USB_XPAD
+  Say Y here if you want to use the X-Box pad with your computer.
+  Make sure to say Y to "Joystick support" (CONFIG_INPUT_JOYDEV)
+  and/or "Event interface support" (CONFIG_INPUT_EVDEV) as well.
+
+  For information about how to connect the X-Box pad to USB, see
+  Documentation/input/xpad.txt.
+
+  This driver is also available as a module ( = code which can be
+  inserted in and removed from the running kernel whenever you want).
+  The module will be called wacom.o.  If you want to compile it as a
+  module, say M here and read <file:Documentation/modules.txt>.
+
diff -Nru a/drivers/usb/input/Config.in b/drivers/usb/input/Config.in
--- a/drivers/usb/input/Config.in	Fri Jul 12 11:44:59 2002
+++ b/drivers/usb/input/Config.in	Fri Jul 12 11:44:59 2002
@@ -23,4 +23,4 @@
 dep_tristate '  Aiptek 6000U/8000U tablet support' CONFIG_USB_AIPTEK $CONFIG_USB $CONFIG_INPUT
 dep_tristate '  Wacom Intuos/Graphire tablet support' CONFIG_USB_WACOM $CONFIG_USB $CONFIG_INPUT
 dep_tristate '  Griffin PowerMate and Contour Jog support' CONFIG_USB_POWERMATE $CONFIG_USB $CONFIG_INPUT
-
+dep_tristate '  X-Box gamepad support' CONFIG_USB_XPAD $CONFIG_USB $CONFIG_INPUT
diff -Nru a/drivers/usb/input/Makefile b/drivers/usb/input/Makefile
--- a/drivers/usb/input/Makefile	Fri Jul 12 11:44:58 2002
+++ b/drivers/usb/input/Makefile	Fri Jul 12 11:44:58 2002
@@ -32,5 +32,6 @@
 obj-$(CONFIG_USB_MOUSE)		+= usbmouse.o
 obj-$(CONFIG_USB_WACOM)		+= wacom.o
 obj-$(CONFIG_USB_POWERMATE)	+= powermate.o
+obj-$(CONFIG_USB_XPAD)		+= xpad.o
 
 include $(TOPDIR)/Rules.make
diff -Nru a/drivers/usb/input/xpad.c b/drivers/usb/input/xpad.c
--- /dev/null	Wed Dec 31 16:00:00 1969
+++ b/drivers/usb/input/xpad.c	Fri Jul 12 11:44:59 2002
@@ -0,0 +1,330 @@
+/*
+ * USB XBOX HID Gamecontroller - v0.0.3
+ *
+ * Copyright (c) 2002 Marko Friedemann <mfr@bmx-chemnitz.de>
+ *
+ *
+ *      This program is free software; you can redistribute it and/or
+ *      modify it under the terms of the GNU General Public License as
+ *      published by the Free Software Foundation; either version 2 of
+ *      the License, or (at your option) any later version.
+ *
+ *      This program is distributed in the hope that it will be useful,
+ *      but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *      GNU General Public License for more details.
+ *
+ *      You should have received a copy of the GNU General Public License
+ *      along with this program; if not, write to the Free Software
+ *      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ *
+ *
+ * This driver is based on:
+ *  - information from      http://euc.jp/periphs/xbox-controller.ja.html
+ *  - the iForce driver     drivers/char/joystick/iforce.c
+ *  - the skeleton-driver   drivers/usb/usb-skeleton.c
+ *
+ * Thanks to:
+ *  - ITO Takayuki for providing xpad information on his website
+ *  - Vojtech Pavlik      - iforce driver / input subsystem
+ *  - Greg Kroah-Hartman  - usb-skeleton driver
+ *
+ * TODO:
+ *	- get the black button to work
+ *      - fine tune axes
+ *      - fix "analog" buttons
+ *	- get rumble working
+ *
+ * History:
+ *
+ * 2002-06-27 - 0.0.1 - first version, just said "XBOX HID controller"
+ *
+ * 2002-07-02 - 0.0.2 - basic working version
+ *      all axes and 9 of the 10 buttons work (german InterAct device)
+ *      the black button does not work
+ *
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/input.h>
+#include <linux/sched.h>
+#include <linux/signal.h>
+#include <linux/errno.h>
+#include <linux/poll.h>
+#include <linux/init.h>
+#include <linux/slab.h>
+#include <linux/fcntl.h>
+#include <linux/module.h>
+#include <linux/spinlock.h>
+#include <linux/list.h>
+#include <linux/smp_lock.h>
+#include <linux/devfs_fs_kernel.h>
+#include <linux/usb.h>
+
+#define DRIVER_VERSION "v0.0.3"
+#define DRIVER_AUTHOR "Marko Friedemann <mfr@bmx-chemnitz.de>"
+#define DRIVER_DESC "X-Box pad driver"
+
+#define XPAD_PKT_LEN 32
+
+static struct xpad_device {
+	u16 idVendor;
+	u16 idProduct;
+	char *name;
+} xpad_device[] = {
+	{ 0x045e, 0x0202, "Microsoft X-Box pad (US)" },
+	{ 0x045e, 0x0285, "Microsoft X-Box pad (Japan)" },
+	{ 0x05fd, 0x107a, "InterAct X-Box pad (Germany)" },
+	{ 0x0000, 0x0000, "X-Box pad" }
+};
+
+static signed short xpad_btn[] = {
+	BTN_A, BTN_B, BTN_C, BTN_X, BTN_Y, BTN_Z,       /* 6 "analog" buttons */
+	BTN_START, BTN_BACK, BTN_THUMBL, BTN_THUMBR,    /* start/back + stick press */
+	-1                                              /* terminating entry */
+};
+
+static signed short xpad_abs[] = {
+	ABS_X, ABS_Y,		/* left stick */
+	ABS_RX, ABS_RY,		/* right stick */
+	ABS_Z, ABS_RZ,		/* triggers left/right */
+	ABS_HAT0X, ABS_HAT0Y,	/* dpad */
+	-1                          /* terminating entry */
+};
+
+static struct {
+	__s32 x;
+	__s32 y;
+} xpad_hat_to_axis[] = { {0, 0}, {0, -1}, {1, -1}, {1, 0}, {1, 1}, {0, 1}, {-1, 1}, {-1, 0}, {-1, -1} };
+
+static struct usb_device_id xpad_table [] = {
+	{ USB_INTERFACE_INFO('X', 'B', 0) },	/* X-Box USB-IF not approved class */
+	{ }
+};
+
+MODULE_DEVICE_TABLE (usb, xpad_table);
+
+struct usb_xpad {
+	struct input_dev dev;			/* input device interface */
+	struct usb_device *udev;		/* usb device */
+	
+	struct urb *irq_in;			/* urb for interrupt in report */
+	unsigned char idata[XPAD_PKT_LEN];	/* input data */
+	
+	char phys[65];				/* physical device path */
+	int open_count;				/* how many times has this been opened */
+};
+
+/*
+ *      xpad_process_packet
+ *
+ *      Completes a request by converting the data into events for the input subsystem.
+ *      
+ *      The used report descriptor given below was taken from ITO Takayukis website:
+ *          http://euc.jp/periphs/xbox-controller.ja.html
+ *
+ * ----------------------------------------------------------------------------------------------------------------
+ * |  padding | byte-cnt | dpad sb12 | reserved |   bt A   |   bt B   |   bt X   |   bt Y   | bt black | bt white |
+ * | 01234567 | 01234567 | 0123 4567 | 01234567 | 01234567 | 01234567 | 01234567 | 01234567 | 01234567 | 01234567 |
+ * |    0     |    1     |     2     |    3     |    4     |    5     |    6     |    7     |    8     |    9     |
+ * ----------------------------------------------------------------------------------------------------------------
+ *
+ * ---------------------------------------------------------------------------------------------------------------
+ * |  trig L  |  trig R  |     left stick X    |     left stick Y    |     right stick X   |     right stick Y   |
+ * | 01234567 | 01234567 | 01234567 | 01234567 | 01234567 | 01234567 | 01234567 | 01234567 | 01234567 | 01234567 |
+ * |    10    |    11    |    12    |    13    |    14    |    15    |    16    |    17    |    18    |    19    |
+ * ---------------------------------------------------------------------------------------------------------------
+ */
+
+static void xpad_process_packet(struct usb_xpad *xpad, u16 cmd, unsigned char *data)
+{
+	struct input_dev *dev = &xpad->dev;
+	
+	/* left stick */
+	input_report_abs(dev, ABS_X, (__s16) (((__s16)data[13] << 8) | data[12]));
+	input_report_abs(dev, ABS_Y, (__s16) (((__s16)data[15] << 8) | data[14]));
+	
+	/* right stick */
+	input_report_abs(dev, ABS_RX, (__s16) (((__s16)data[17] << 8) | data[16]));
+	input_report_abs(dev, ABS_RY, (__s16) (((__s16)data[19] << 8) | data[18]));
+	
+	/* triggers left/right */
+	input_report_abs(dev, ABS_Z, data[10]);
+	input_report_abs(dev, ABS_RZ, data[11]);
+	
+	/* digital pad */
+	input_report_abs(dev, ABS_HAT0X, xpad_hat_to_axis[data[2] & 0x0f].x);
+	input_report_abs(dev, ABS_HAT0Y, xpad_hat_to_axis[data[2] & 0x0f].y);
+	
+	/* start/back buttons and stick press left/right */
+	input_report_key(dev, BTN_START, (data[2] & 0x10) >> 4);
+	input_report_key(dev, BTN_BACK, (data[2] & 0x20) >> 5);
+	input_report_key(dev, BTN_THUMBL, (data[2] & 0x40) >> 6);
+	input_report_key(dev, BTN_THUMBR, data[2] >> 7);
+	
+	/* "analog" buttons A, B, X, Y */
+	input_report_key(dev, BTN_A, data[4]);
+	input_report_key(dev, BTN_B, data[5]);
+	input_report_key(dev, BTN_X, data[6]);
+	input_report_key(dev, BTN_Y, data[7]);
+	
+	/* "analog" buttons black, white */
+	input_report_key(dev, BTN_C, data[8]);
+	input_report_key(dev, BTN_Z, data[9]);
+}
+
+static void xpad_irq_in(struct urb *urb)
+{
+	struct usb_xpad *xpad = urb->context;
+	
+	if (urb->status)
+		return;
+	
+	xpad_process_packet(xpad, 0, xpad->idata);
+}
+
+static int xpad_open (struct input_dev *dev)
+{
+	struct usb_xpad *xpad = dev->private;
+	
+	if (xpad->open_count++)
+		return 0;
+	
+	xpad->irq_in->dev = xpad->udev;
+	if (usb_submit_urb(xpad->irq_in, GFP_KERNEL))
+		return -EIO;
+	
+	return 0;
+}
+
+static void xpad_close (struct input_dev *dev)
+{
+	struct usb_xpad *xpad = dev->private;
+	
+	if (!--xpad->open_count)
+		usb_unlink_urb(xpad->irq_in);
+}
+
+static void * xpad_probe(struct usb_device *udev, unsigned int ifnum, const struct usb_device_id *id)
+{
+	struct usb_xpad *xpad = NULL;
+	struct usb_endpoint_descriptor *ep_irq_in;
+	char path[64];
+	int i;
+	
+	for (i = 0; xpad_device[i].idVendor; i++) {
+		if ((udev->descriptor.idVendor == xpad_device[i].idVendor) &&
+		    (udev->descriptor.idProduct == xpad_device[i].idProduct))
+			break;
+	}
+	
+	if ((xpad = kmalloc (sizeof(struct usb_xpad), GFP_KERNEL)) == NULL) {
+		err("cannot allocate memory for new pad");
+		return NULL;
+	}
+	memset(xpad, 0, sizeof(struct usb_xpad));
+
+	xpad->irq_in = usb_alloc_urb(0, GFP_KERNEL);
+        if (!xpad->irq_in) {
+		err("cannot allocate memory for new pad irq urb");
+                kfree(xpad);
+                return NULL;
+        }
+	
+	ep_irq_in = udev->actconfig->interface[ifnum].altsetting[0].endpoint + 0;
+	
+	FILL_INT_URB(xpad->irq_in, udev, usb_rcvintpipe(udev, ep_irq_in->bEndpointAddress),
+	xpad->idata, XPAD_PKT_LEN, xpad_irq_in, xpad, ep_irq_in->bInterval);
+	
+	xpad->udev = udev;
+
+	xpad->dev.idbus = BUS_USB;
+	xpad->dev.idvendor = udev->descriptor.idVendor;
+	xpad->dev.idproduct = udev->descriptor.idProduct;
+	xpad->dev.idversion = udev->descriptor.bcdDevice;
+	xpad->dev.private = xpad;
+	xpad->dev.name = xpad_device[i].name;
+	xpad->dev.phys = xpad->phys;
+	xpad->dev.open = xpad_open;
+	xpad->dev.close = xpad_close;
+
+	usb_make_path(udev, path, 64);
+	snprintf(xpad->phys, 64,  "%s/input0", path);
+	
+	xpad->dev.evbit[0] = BIT(EV_KEY) | BIT(EV_ABS);
+
+	for (i = 0; xpad_btn[i] >= 0; i++)
+	set_bit(xpad_btn[i], xpad->dev.keybit);
+	
+	for (i = 0; xpad_abs[i] >= 0; i++) {
+
+		signed short t = xpad_abs[i];
+
+		set_bit(t, xpad->dev.absbit);
+		
+		switch (t) {
+			case ABS_X:
+			case ABS_Y:
+			case ABS_RX:
+			case ABS_RY:
+				xpad->dev.absmax[t] =  32767;
+				xpad->dev.absmin[t] = -32768;
+				xpad->dev.absflat[t] = 128;
+				xpad->dev.absfuzz[t] = 16;
+				break;
+			case ABS_Z:
+			case ABS_RZ:
+				xpad->dev.absmax[t] = 255;
+				xpad->dev.absmin[t] = 0;
+				break;
+			case ABS_HAT0X:
+			case ABS_HAT0Y:
+				xpad->dev.absmax[t] =  1;
+				xpad->dev.absmin[t] = -1;
+				break;
+		}
+	}
+	
+	input_register_device(&xpad->dev);
+	
+	printk(KERN_INFO "input: %s on %s", xpad->dev.name, path);
+	
+	return xpad;
+}
+
+static void xpad_disconnect(struct usb_device *udev, void *ptr)
+{
+	struct usb_xpad *xpad = ptr;
+	
+	usb_unlink_urb(xpad->irq_in);
+	input_unregister_device(&xpad->dev);
+	usb_free_urb(xpad->irq_in);
+	kfree(xpad);
+}
+
+static struct usb_driver xpad_driver = {
+	name:       "xpad",
+	probe:      xpad_probe,
+	disconnect: xpad_disconnect,
+	id_table:   xpad_table,
+};
+
+static int __init usb_xpad_init(void)
+{
+	usb_register(&xpad_driver);
+	info(DRIVER_DESC ":" DRIVER_VERSION);
+	return 0;
+}
+
+static void __exit usb_xpad_exit(void)
+{
+	usb_deregister(&xpad_driver);
+}
+
+module_init(usb_xpad_init);
+module_exit(usb_xpad_exit);
+
+MODULE_AUTHOR(DRIVER_AUTHOR);
+MODULE_DESCRIPTION(DRIVER_DESC);
+MODULE_LICENSE("GPL");
